(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'melon-core/classname/cxBuilder', './breadcrumb/Item'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('melon-core/classname/cxBuilder'), require('./breadcrumb/Item'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.cxBuilder, global.Item);
        global.Breadcrumb = mod.exports;
    }
})(this, function (exports, _react, _cxBuilder, _Item) {
    'use strict';

    exports.__esModule = true;
    exports.Item = exports.default = undefined;

    var _react2 = _interopRequireDefault(_react);

    var _Item2 = _interopRequireDefault(_Item);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    var cx = (0, _cxBuilder.create)('Breadcrumb');

    /* eslint-disable fecs-prefer-class */

    /**
     * melon/Breadcrumb
     *
     * @class
     * @param {Object}  props 属性
     * @return {ReactElement}
     */
    function Breadcrumb(props) {
        var children = props.children,
            rest = _objectWithoutProperties(props, ['children']);

        return _react2.default.createElement(
            'div',
            _extends({}, rest, { className: cx(props).build() }),
            _react2.default.Children.map(children, function (child, index) {
                return child && child.type === _Item2.default ? _react2.default.cloneElement(child, {
                    key: index,
                    level: index
                }) : null;
            })
        );
    }
    /* eslint-enable fecs-prefer-class */

    Breadcrumb.Item = _Item2.default;

    Breadcrumb.createCrumbs = function (crumbs) {

        return crumbs.map(function (crumb, index) {
            var text = crumb.text,
                rest = _objectWithoutProperties(crumb, ['text']);

            return _react2.default.createElement(
                _Item2.default,
                _extends({}, rest, {
                    key: index,
                    level: index }),
                text
            );
        });
    };

    exports.default = Breadcrumb;
    exports.Item = _Item2.default;
});
//# sourceMappingURL=Breadcrumb.js.map
