(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.cxBuilder);
        global.Card = mod.exports;
    }
})(this, function (exports, _react, _cxBuilder) {
    'use strict';

    exports.__esModule = true;
    exports.default = Card;

    var _react2 = _interopRequireDefault(_react);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    /**
     * @file Card
     * @author leon(ludafa@outlook.com)
     */

    var cx = (0, _cxBuilder.create)('Card');

    /* eslint-disable fecs-prefer-class */

    /**
     * melon/Card
     *
     * @class
     * @param {Object}  props           属性
     * @return {ReactElement}
     */
    function Card(props) {

        var children = props.children;

        return _react2.default.createElement(
            'div',
            { className: cx(props).build() },
            children
        );
    }
    /* eslint-enable fecs-prefer-class */

    Card.displayName = 'Card';
});
//# sourceMappingURL=Card.js.map
