(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', './Icon', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('./Icon'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.Icon, global.cxBuilder);
        global.Chip = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _Icon, _cxBuilder) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Icon2 = _interopRequireDefault(_Icon);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('Chip');

    var Chip = function (_Component) {
        _inherits(Chip, _Component);

        function Chip() {
            var _temp, _this, _ret;

            _classCallCheck(this, Chip);

            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.handleClick = function (event) {
                if (_this.props.onClick) {
                    _this.props.onClick(event);
                }
            }, _this.handleRemoveIconClick = function (event) {
                event.stopPropagation();
                if (_this.props.onRemove) {
                    _this.props.onRemove(event);
                }
            }, _this.renderAvatar = function () {

                var avatarUiClassName = cx.getPartClassName('avatar');

                var _this$props$avatar = _this.props.avatar,
                    avatar = _this$props$avatar === undefined ? null : _this$props$avatar;

                if (avatar) {
                    var className = avatar.props.className ? ~avatar.props.className.indexOf(avatarUiClassName) ? avatar.props.className : avatar.props.className + ' ' + avatarUiClassName : avatarUiClassName;

                    avatar = _react2.default.cloneElement(avatar, {
                        className: className
                    });
                }

                return avatar;
            }, _temp), _possibleConstructorReturn(_this, _ret);
        }

        Chip.prototype.renderRemoveIcon = function renderRemoveIcon() {
            var _props = this.props,
                onRemove = _props.onRemove,
                removeIconStyle = _props.removeIconStyle;

            if (onRemove) {
                return _react2.default.createElement(
                    'div',
                    {
                        className: cx.getPartClassName('icon') },
                    _react2.default.createElement(_Icon2.default, {
                        icon: 'close',
                        onClick: this.handleRemoveIconClick,
                        style: removeIconStyle })
                );
            }
        };

        Chip.prototype.renderLabel = function renderLabel() {
            // 如果有remove icon 那么label的padding-right为0
            var labelStyle = {};
            if (this.props.onRemove) {
                labelStyle.paddingRight = 0;
            }

            return _react2.default.createElement(
                'span',
                {
                    className: cx.getPartClassName('label'),
                    style: labelStyle },
                this.props.children
            );
        };

        Chip.prototype.render = function render() {
            var _props2 = this.props,
                onClick = _props2.onClick,
                onRemove = _props2.onRemove,
                style = _props2.style;


            var className = cx(this.props).addStates({
                active: !!(onClick || onRemove)
            }).build();

            return _react2.default.createElement(
                'div',
                {
                    className: className,
                    onClick: this.handleClick,
                    style: style },
                _react2.default.createElement(
                    'div',
                    { style: { display: 'table' } },
                    this.renderAvatar(),
                    this.renderLabel(),
                    this.renderRemoveIcon()
                )
            );
        };

        return Chip;
    }(_react.Component);

    Chip.displayName = 'Chip';
    Chip.propTypes = {
        style: _propTypes2.default.object,
        removeIconStyle: _propTypes2.default.object,
        avatar: _propTypes2.default.element,
        onClick: _propTypes2.default.func,
        onRemove: _propTypes2.default.func
    };
    exports.default = Chip;
});
//# sourceMappingURL=Chip.js.map
