(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', './Menu', './Popover', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('./Menu'), require('./Popover'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.Menu, global.Popover, global.cxBuilder);
        global.DropDownMenu = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _Menu, _Popover, _cxBuilder) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Menu2 = _interopRequireDefault(_Menu);

    var _Popover2 = _interopRequireDefault(_Popover);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('DropDownMenu');

    var DropDownMenu = function (_Component) {
        _inherits(DropDownMenu, _Component);

        function DropDownMenu(props, context) {
            _classCallCheck(this, DropDownMenu);

            var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

            _this.onClose = _this.onClose.bind(_this);
            _this.onOpen = _this.onOpen.bind(_this);
            _this.state = {
                open: false
            };
            return _this;
        }

        DropDownMenu.prototype.onOpen = function onOpen() {
            this.setState({
                open: true
            });
        };

        DropDownMenu.prototype.onClose = function onClose() {
            this.setState({
                open: false
            });
        };

        DropDownMenu.prototype.render = function render() {
            var _props = this.props,
                label = _props.label,
                children = _props.children,
                maxHeight = _props.maxHeight,
                style = _props.style,
                anchorAlignment = _props.anchorAlignment,
                layerAlignment = _props.layerAlignment,
                anchorOffset = _props.anchorOffset,
                layerOffset = _props.layerOffset;


            return _react2.default.createElement(
                'div',
                { className: cx(this.props).build(),
                    ref: 'main',
                    style: style,
                    onClick: this.onOpen },
                label,
                _react2.default.createElement(
                    _Popover2.default,
                    {
                        autoWidth: true,
                        maxHeight: maxHeight,
                        open: this.state.open,
                        anchor: this.refs.main,
                        onRequestClose: this.onClose,
                        anchorOffset: anchorOffset,
                        layerOffset: layerOffset,
                        anchorAlignment: anchorAlignment,
                        layerAlignment: layerAlignment },
                    _react2.default.createElement(
                        _Menu2.default,
                        { onClose: this.onClose },
                        children
                    )
                )
            );
        };

        return DropDownMenu;
    }(_react.Component);

    exports.default = DropDownMenu;


    DropDownMenu.propTypes = {
        label: _propTypes2.default.element.isRequired,
        maxHeight: _propTypes2.default.number
    };
});
//# sourceMappingURL=DropDownMenu.js.map
