(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder', 'lodash/omit'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'), require('lodash/omit'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder, global.omit);
        global.Icon = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder, _omit) {
    'use strict';

    exports.__esModule = true;
    exports.default = Icon;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _omit2 = _interopRequireDefault(_omit);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    var cx = (0, _cxBuilder.create)('Icon');

    /* eslint-disable fecs-prefer-class */

    /**
     * melon/Icon
     *
     * @class
     * @param {Object} props     属性
     * @param {string} props.icon icon名称
     * @return {ReactElement}
     */
    function Icon(props) {
        var icon = props.icon,
            rest = _objectWithoutProperties(props, ['icon']);

        return _react2.default.createElement('i', _extends({}, (0, _omit2.default)(rest, ['states', 'variants']), {
            'data-icon': icon,
            className: cx(props).build() }));
    }

    Icon.propTypes = {
        icon: _propTypes2.default.string.isRequired
    };

    Icon.displayName = 'Icon';
});
//# sourceMappingURL=Icon.js.map
