(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'melon-core/classname/cxBuilder', 'lodash/omit'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('melon-core/classname/cxBuilder'), require('lodash/omit'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.cxBuilder, global.omit);
    global.Link = mod.exports;
  }
})(this, function (exports, _react, _cxBuilder, _omit) {
  'use strict';

  exports.__esModule = true;
  exports.default = Link;

  var _react2 = _interopRequireDefault(_react);

  var _omit2 = _interopRequireDefault(_omit);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var cx = (0, _cxBuilder.create)('Link');

  /* eslint-disable fecs-prefer-class */

  /**
   * melon/Link
   *
   * @class
   * @param {Object} props     属性
   * @return {ReactElement}
   */
  function Link(props) {

    return _react2.default.createElement('a', _extends({}, (0, _omit2.default)(props, ['variants', 'states']), { className: cx(props).build() }));
  }

  Link.displayName = 'Link';

  /* eslint-enable fecs-prefer-class */
});
//# sourceMappingURL=Link.js.map
