(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder', './dialog/windowScrollHelper', 'lodash/omit'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'), require('./dialog/windowScrollHelper'), require('lodash/omit'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder, global.windowScrollHelper, global.omit);
        global.Mask = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder, _windowScrollHelper, _omit) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var windowScrollHelper = _interopRequireWildcard(_windowScrollHelper);

    var _omit2 = _interopRequireDefault(_omit);

    function _interopRequireWildcard(obj) {
        if (obj && obj.__esModule) {
            return obj;
        } else {
            var newObj = {};

            if (obj != null) {
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
                }
            }

            newObj.default = obj;
            return newObj;
        }
    }

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('Mask');

    /**
     * melon/Pager
     *
     * @extends {React.Component}
     * @class
     */

    var Mask = function (_Component) {
        _inherits(Mask, _Component);

        function Mask() {
            _classCallCheck(this, Mask);

            return _possibleConstructorReturn(this, _Component.apply(this, arguments));
        }

        Mask.prototype.componentDidMount = function componentDidMount() {
            var _props = this.props,
                show = _props.show,
                lockScrollingOnShow = _props.lockScrollingOnShow;


            if (show && lockScrollingOnShow) {
                this.lockScroll();
            }
        };

        Mask.prototype.shouldComponentUpdate = function shouldComponentUpdate(_ref) {
            var show = _ref.show;

            return this.props.show !== show;
        };

        Mask.prototype.componentDidUpdate = function componentDidUpdate() {
            var _props2 = this.props,
                show = _props2.show,
                lockScrollingOnShow = _props2.lockScrollingOnShow;

            show && lockScrollingOnShow ? this.lockScroll() : this.unlockScroll();
        };

        Mask.prototype.componentWillUnmount = function componentWillUnmount() {
            this.unlockScroll();
        };

        Mask.prototype.lockScroll = function lockScroll() {
            windowScrollHelper.stop();
        };

        Mask.prototype.unlockScroll = function unlockScroll() {
            windowScrollHelper.restore();
        };

        Mask.prototype.render = function render() {
            var _props3 = this.props,
                show = _props3.show,
                variants = _props3.variants,
                states = _props3.states,
                rest = _objectWithoutProperties(_props3, ['show', 'variants', 'states']);

            var className = cx().addVariants(variants).addStates(_extends({}, states, {
                show: show
            })).build();

            return _react2.default.createElement('div', _extends({}, (0, _omit2.default)(rest, 'lockScrollingOnShow'), {
                className: className }));
        };

        return Mask;
    }(_react.Component);

    exports.default = Mask;


    Mask.defaultProps = {
        lockScrollingOnShow: true,
        show: false
    };

    Mask.propTypes = {
        lockScrollingOnShow: _propTypes2.default.bool,
        show: _propTypes2.default.bool
    };
});
//# sourceMappingURL=Mask.js.map
