(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', './region/Selector', './region/Area', './region/helper', 'melon-core/InputComponent', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('./region/Selector'), require('./region/Area'), require('./region/helper'), require('melon-core/InputComponent'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.Selector, global.Area, global.helper, global.InputComponent, global.cxBuilder);
        global.Region = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _Selector, _Area, _helper, _InputComponent2, _cxBuilder) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Selector2 = _interopRequireDefault(_Selector);

    var _Area2 = _interopRequireDefault(_Area);

    var helper = _interopRequireWildcard(_helper);

    var _InputComponent3 = _interopRequireDefault(_InputComponent2);

    function _interopRequireWildcard(obj) {
        if (obj && obj.__esModule) {
            return obj;
        } else {
            var newObj = {};

            if (obj != null) {
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
                }
            }

            newObj.default = obj;
            return newObj;
        }
    }

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('Region');

    var Region = function (_InputComponent) {
        _inherits(Region, _InputComponent);

        function Region(props, context) {
            _classCallCheck(this, Region);

            var _this = _possibleConstructorReturn(this, _InputComponent.call(this, props, context));

            _this.state = _extends({}, _this.state, {
                datasource: _this.props.datasource
            });

            _this.onChange = _this.onChange.bind(_this);
            _this.onSelectorChange = _this.onSelectorChange.bind(_this);

            return _this;
        }

        Region.prototype.onChange = function onChange(rawValue) {

            _InputComponent.prototype.onChange.call(this, {
                type: 'change',
                target: this,
                value: this.stringifyValue(rawValue)
            });
        };

        Region.prototype.onAreaChange = function onAreaChange(index, cIndex, e) {

            var data = e.data;
            var datasource = this.state.datasource;

            helper.isAllSelected(data);
            datasource[cIndex].children[index] = data;
            helper.isAllSelected(datasource[cIndex]);

            this.setState({ datasource: datasource }, function () {
                this.onChange(datasource);
            });
        };

        Region.prototype.onSelectorChange = function onSelectorChange(index, _ref) {
            var value = _ref.value;


            var datasource = this.state.datasource;

            helper[value ? 'selectAll' : 'cancelAll'](datasource[index]);

            this.setState({ datasource: datasource }, function () {
                this.onChange(datasource);
            });
        };

        Region.prototype.parseValue = function parseValue(value) {
            value = value.split(',');
            return this.props.datasource.map(helper.parse.bind(this, value));
        };

        Region.prototype.stringifyValue = function stringifyValue(datasource) {
            var _this2 = this;

            return datasource ? datasource.reduce(function () {
                return _this2.format.apply(_this2, arguments);
            }, []).join(',') : '';
        };

        Region.prototype.format = function format(result, child, index) {
            var _this3 = this;

            if (child.selected) {
                result.push(child.id);
            }

            return child.children ? child.children.reduce(function () {
                return _this3.format.apply(_this3, arguments);
            }, result) : result;
        };

        Region.prototype.renderCountry = function renderCountry(country, index) {
            var _this4 = this;

            return _react2.default.createElement(
                'div',
                { className: cx().part('country').build(), key: index },
                _react2.default.createElement(
                    'h1',
                    null,
                    _react2.default.createElement(_Selector2.default, {
                        label: country.text,
                        id: country.id,
                        index: index,
                        checked: country.selected,
                        onChange: function onChange(e) {
                            _this4.onSelectorChange(index, e);
                        } })
                ),
                this.renderArea(country.children, index)
            );
        };

        Region.prototype.renderArea = function renderArea(area, cIndex) {
            var _this5 = this;

            return Array.isArray(area) && area.length > 0 ? _react2.default.createElement(
                'ul',
                null,
                area.map(function (a, index) {
                    return _react2.default.createElement(_Area2.default, {
                        key: index,
                        variants: index % 2 ? ['even'] : [],
                        datasource: a,
                        onChange: function onChange(e) {
                            _this5.onAreaChange(index, cIndex, e);
                        } });
                })
            ) : null;
        };

        Region.prototype.render = function render() {
            var _this6 = this;

            var datasource = this.state.datasource;

            return _react2.default.createElement(
                'div',
                { className: cx(this.props).build() },
                datasource.map(function () {
                    return _this6.renderCountry.apply(_this6, arguments);
                })
            );
        };

        return Region;
    }(_InputComponent3.default);

    exports.default = Region;


    Region.defaultProps = _extends({}, _InputComponent3.default.defaultProps, {
        datasource: []
    });

    Region.propTypes = _extends({}, _InputComponent3.default.propTypes, {
        selected: _propTypes2.default.bool,
        datasource: _propTypes2.default.arrayOf(_propTypes2.default.object)
    });

    Region.childContextTypes = _InputComponent3.default.childContextTypes;
    Region.contextTypes = _InputComponent3.default.contextTypes;
});
//# sourceMappingURL=Region.js.map
