(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder);
        global.Title = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder) {
    'use strict';

    exports.__esModule = true;
    exports.default = Title;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    var cx = (0, _cxBuilder.create)('Title');

    /* eslint-disable fecs-prefer-class */

    /**
     * melon/Title
     *
     * @class
     * @param {Object}  props       属性
     * @param {Object}  props.level 级别
     * @return {ReactElement}
     */
    function Title(props) {
        var level = props.level,
            variants = props.variants,
            states = props.states,
            rest = _objectWithoutProperties(props, ['level', 'variants', 'states']);

        var Type = 'h' + level;
        var className = cx(props).addVariants(variants).addStates(states).build();

        return _react2.default.createElement(Type, _extends({}, rest, { className: className }));
    }

    Title.propsTypes = {
        level: _propTypes2.default.oneOf([1, 2, 3, 4, 5, 6]).isRequired
    };

    Title.defaultProps = {
        level: 1
    };
});
//# sourceMappingURL=Title.js.map
