(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.cxBuilder);
        global.ToolBar = mod.exports;
    }
})(this, function (exports, _react, _cxBuilder) {
    'use strict';

    exports.__esModule = true;
    exports.default = ToolBar;

    var _react2 = _interopRequireDefault(_react);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    /**
     * @file ToolBar
     * @author leon(ludafa@outlook.com)
     */

    var cx = (0, _cxBuilder.create)('ToolBar');

    /**
     * melon/ToolBar
     *
     * @class
     * @param {Object}  props        属性
     * @return {ReactElement}
     */
    function ToolBar(props) {

        var children = props.children;

        return _react2.default.createElement(
            'div',
            { className: cx(props).build() },
            children
        );
    }

    ToolBar.displayName = 'ToolBar';
});
//# sourceMappingURL=ToolBar.js.map
