(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder);
        global.Zippy = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('Zippy');

    /**
     * melon/Zippy
     *
     * @extends {React.Component}
     * @class
     */

    var Zippy = function (_Component) {
        _inherits(Zippy, _Component);

        function Zippy() {
            _classCallCheck(this, Zippy);

            return _possibleConstructorReturn(this, _Component.apply(this, arguments));
        }

        Zippy.prototype.render = function render() {

            var props = this.props;

            var expand = props.expand,
                direction = props.direction,
                variants = props.variants,
                states = props.states,
                others = _objectWithoutProperties(props, ['expand', 'direction', 'variants', 'states']);

            var className = cx().addVariants(variants).addStates(states).addVariants(direction).addStates({ close: !expand }).build();

            var style = this.props.style;
            var isVertical = direction === 'vertical';
            var transform = 'scale(' + (isVertical ? 1 : 0) + ', ' + (isVertical ? 0 : 1) + ')';

            if (!expand) {
                style = _extends({}, style, {
                    WebkitTransform: transform,
                    MozTransform: transform,
                    msTransform: transform,
                    transform: transform
                });
            }

            return _react2.default.createElement('div', _extends({}, others, { style: style, className: className }));
        };

        return Zippy;
    }(_react.Component);

    exports.default = Zippy;


    Zippy.displayName = 'Zippy';

    Zippy.propTypes = {
        direction: _propTypes2.default.oneOf(['vertical', 'horizontal']),
        expand: _propTypes2.default.bool
    };

    Zippy.defaultProps = {
        direction: 'vertical',
        expand: false
    };
});
//# sourceMappingURL=Zippy.js.map
