(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder', 'melon-core/util/shallowEqual'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'), require('melon-core/util/shallowEqual'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder, global.shallowEqual);
        global.DialogWindow = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder, _shallowEqual) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('DialogWindow');

    var DialogWindow = function (_Component) {
        _inherits(DialogWindow, _Component);

        function DialogWindow() {
            _classCallCheck(this, DialogWindow);

            return _possibleConstructorReturn(this, _Component.apply(this, arguments));
        }

        DialogWindow.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
            return !(0, _shallowEqual2.default)(this.props, nextProps);
        };

        DialogWindow.prototype.render = function render() {
            var _props = this.props,
                children = _props.children,
                title = _props.title,
                footer = _props.footer,
                width = _props.width,
                style = _props.style,
                others = _objectWithoutProperties(_props, ['children', 'title', 'footer', 'width', 'style']);

            return _react2.default.createElement(
                'div',
                _extends({}, others, {
                    style: _extends({}, style, { width: width + 'px' }),
                    className: cx(this.props).build() }),
                title,
                children,
                footer
            );
        };

        return DialogWindow;
    }(_react.Component);

    exports.default = DialogWindow;


    DialogWindow.propTypes = {
        footer: _propTypes2.default.element,
        title: _propTypes2.default.element
    };
});
//# sourceMappingURL=DialogWindow.js.map
