(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', '../Title'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('../Title'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.Title);
        global.Header = mod.exports;
    }
})(this, function (exports, _react, _Title) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _Title2 = _interopRequireDefault(_Title);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var NavigationHeader = function (_Component) {
        _inherits(NavigationHeader, _Component);

        function NavigationHeader() {
            _classCallCheck(this, NavigationHeader);

            return _possibleConstructorReturn(this, _Component.apply(this, arguments));
        }

        NavigationHeader.prototype.render = function render() {
            var _props = this.props,
                children = _props.children,
                _props$variants = _props.variants,
                variants = _props$variants === undefined ? [] : _props$variants,
                rest = _objectWithoutProperties(_props, ['children', 'variants']);

            return _react2.default.createElement(
                _Title2.default,
                _extends({}, rest, {
                    level: 4,
                    variants: [].concat(variants, ['navigation-header']) }),
                children
            );
        };

        return NavigationHeader;
    }(_react.Component);

    exports.default = NavigationHeader;
});
//# sourceMappingURL=Header.js.map
