(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder', './Selector', './Province', './City', './helper'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'), require('./Selector'), require('./Province'), require('./City'), require('./helper'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder, global.Selector, global.Province, global.City, global.helper);
        global.Area = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder, _Selector, _Province, _City, _helper) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Selector2 = _interopRequireDefault(_Selector);

    var _Province2 = _interopRequireDefault(_Province);

    var _City2 = _interopRequireDefault(_City);

    var helper = _interopRequireWildcard(_helper);

    function _interopRequireWildcard(obj) {
        if (obj && obj.__esModule) {
            return obj;
        } else {
            var newObj = {};

            if (obj != null) {
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
                }
            }

            newObj.default = obj;
            return newObj;
        }
    }

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('RegionArea');

    var RegionArea = function (_Component) {
        _inherits(RegionArea, _Component);

        function RegionArea(props) {
            _classCallCheck(this, RegionArea);

            var _this = _possibleConstructorReturn(this, _Component.call(this, props));

            _this.onSelectorChange = _this.onSelectorChange.bind(_this);
            _this.onProvinceChange = _this.onProvinceChange.bind(_this);

            return _this;
        }

        RegionArea.prototype.onSelectorChange = function onSelectorChange(e) {

            var value = e.value;
            var _props = this.props,
                datasource = _props.datasource,
                onChange = _props.onChange;


            helper[value ? 'selectAll' : 'cancelAll'](datasource);

            onChange && onChange({
                data: datasource
            });
        };

        RegionArea.prototype.onProvinceChange = function onProvinceChange(index, e) {

            var data = e.data;
            var _props2 = this.props,
                datasource = _props2.datasource,
                onChange = _props2.onChange;


            datasource.children[index] = data;

            helper.isAllSelected(datasource);

            onChange && onChange({
                data: datasource
            });
        };

        RegionArea.prototype.onCityChange = function onCityChange(pIndex, cIndex, e) {

            var data = e.data;

            var _props3 = this.props,
                datasource = _props3.datasource,
                onChange = _props3.onChange;


            var p = datasource.children[pIndex];

            p.children[cIndex] = data;

            helper.isAllSelected(p);

            onChange && onChange({
                data: datasource
            });
        };

        RegionArea.prototype.renderProvince = function renderProvince(child, index) {
            var _this2 = this;

            return _react2.default.createElement(
                _Province2.default,
                {
                    key: index,
                    datasource: child,
                    onChange: this.onProvinceChange.bind(this, index) },
                Array.isArray(child.children) && child.children.length > 0 ? child.children.map(function (child, i) {
                    return _this2.renderCity(index, child, i);
                }) : null
            );
        };

        RegionArea.prototype.renderCity = function renderCity(pIndex, child, index) {
            var _this3 = this;

            return _react2.default.createElement(_City2.default, {
                key: index,
                datasource: child,
                onChange: function onChange(e) {
                    return _this3.onCityChange(pIndex, index, e);
                } });
        };

        RegionArea.prototype.render = function render() {
            var _this4 = this;

            var datasource = this.props.datasource;

            return _react2.default.createElement(
                'li',
                { className: cx(this.props).build() },
                _react2.default.createElement(
                    'div',
                    { className: cx().part('selector').build() },
                    _react2.default.createElement(_Selector2.default, {
                        label: datasource.text,
                        id: datasource.id,
                        checked: datasource.selected,
                        onChange: this.onSelectorChange })
                ),
                _react2.default.createElement(
                    'div',
                    { className: cx().part('content').build() },
                    datasource.children.map(function () {
                        return _this4.renderProvince.apply(_this4, arguments);
                    })
                )
            );
        };

        return RegionArea;
    }(_react.Component);

    exports.default = RegionArea;


    RegionArea.displayName = 'RegionArea';

    RegionArea.propTypes = {
        onChange: _propTypes2.default.func,
        disabled: _propTypes2.default.bool,
        datasource: _propTypes2.default.object
    };
});
//# sourceMappingURL=Area.js.map
