(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder', './Selector'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'), require('./Selector'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder, global.Selector);
        global.City = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder, _Selector) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Selector2 = _interopRequireDefault(_Selector);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('RegionCity');

    var RegionCity = function (_Component) {
        _inherits(RegionCity, _Component);

        function RegionCity(props) {
            _classCallCheck(this, RegionCity);

            var _this = _possibleConstructorReturn(this, _Component.call(this, props));

            _this.onSelectorChange = _this.onSelectorChange.bind(_this);

            return _this;
        }

        RegionCity.prototype.onSelectorChange = function onSelectorChange(e) {

            var value = e.value;

            var _props = this.props,
                datasource = _props.datasource,
                onChange = _props.onChange;


            datasource.selected = value;

            onChange && onChange({
                data: datasource
            });
        };

        RegionCity.prototype.render = function render() {

            var datasource = this.props.datasource;

            return _react2.default.createElement(
                'li',
                { className: cx(this.props).build() },
                _react2.default.createElement(_Selector2.default, {
                    label: datasource.text,
                    id: datasource.id,
                    checked: datasource.selected,
                    onChange: this.onSelectorChange })
            );
        };

        return RegionCity;
    }(_react.Component);

    exports.default = RegionCity;


    RegionCity.displayName = 'RegionCity';

    RegionCity.propTypes = {
        onChange: _propTypes2.default.func,
        disabled: _propTypes2.default.bool,
        datasource: _propTypes2.default.object
    };
});
//# sourceMappingURL=City.js.map
