(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder', './Selector', './helper'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'), require('./Selector'), require('./helper'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder, global.Selector, global.helper);
        global.Province = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder, _Selector, _helper) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Selector2 = _interopRequireDefault(_Selector);

    var helper = _interopRequireWildcard(_helper);

    function _interopRequireWildcard(obj) {
        if (obj && obj.__esModule) {
            return obj;
        } else {
            var newObj = {};

            if (obj != null) {
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
                }
            }

            newObj.default = obj;
            return newObj;
        }
    }

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('RegionProvince');

    var RegionProvince = function (_Component) {
        _inherits(RegionProvince, _Component);

        function RegionProvince(props) {
            _classCallCheck(this, RegionProvince);

            var _this = _possibleConstructorReturn(this, _Component.call(this, props));

            _this.state = {
                expand: false
            };

            _this.onSelectorChange = _this.onSelectorChange.bind(_this);
            _this.onMouseEnter = _this.onMouseEnter.bind(_this);
            _this.onMouseLeave = _this.onMouseLeave.bind(_this);

            return _this;
        }

        RegionProvince.prototype.onSelectorChange = function onSelectorChange(e) {

            var value = e.value;
            var _props = this.props,
                datasource = _props.datasource,
                onChange = _props.onChange;


            helper[value ? 'selectAll' : 'cancelAll'](datasource);

            onChange && onChange({
                data: datasource
            });
        };

        RegionProvince.prototype.onMouseEnter = function onMouseEnter(e) {
            this.setState({ expand: true });
        };

        RegionProvince.prototype.onMouseLeave = function onMouseLeave(e) {
            this.setState({ expand: false });
        };

        RegionProvince.prototype.renderSelectedInfo = function renderSelectedInfo() {

            var datasource = this.props.datasource;

            var total = datasource.children && datasource.children.length;

            if (!total) {
                return;
            }

            var num = datasource.children.reduce(function (result, child, index) {
                if (child.selected) {
                    result++;
                }
                return result;
            }, 0);

            return num === total || num === 0 ? null : _react2.default.createElement(
                'span',
                { className: cx().part('info').build() },
                '(' + num + '/' + total + ')'
            );
        };

        RegionProvince.prototype.render = function render() {
            var _props2 = this.props,
                datasource = _props2.datasource,
                children = _props2.children;


            return _react2.default.createElement(
                'div',
                { className: cx(this.props).addStates({ expand: this.state.expand }).build(),
                    onMouseEnter: children ? this.onMouseEnter : null,
                    onMouseLeave: children ? this.onMouseLeave : null },
                _react2.default.createElement(_Selector2.default, {
                    label: datasource.text,
                    id: datasource.id,
                    checked: datasource.selected,
                    onChange: this.onSelectorChange }),
                this.renderSelectedInfo(),
                children ? _react2.default.createElement(
                    'div',
                    { className: cx().part('popup').build() },
                    _react2.default.createElement(
                        'ul',
                        null,
                        children
                    )
                ) : null
            );
        };

        return RegionProvince;
    }(_react.Component);

    exports.default = RegionProvince;


    RegionProvince.propTypes = {
        onChange: _propTypes2.default.func,
        disabled: _propTypes2.default.bool,
        datasource: _propTypes2.default.object
    };
});
//# sourceMappingURL=Province.js.map
