(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder', './RippleCircle', 'react-motion'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'), require('./RippleCircle'), require('react-motion'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder, global.RippleCircle, global.reactMotion);
        global.CenterRipple = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder, _RippleCircle, _reactMotion) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _RippleCircle2 = _interopRequireDefault(_RippleCircle);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('CenterRipple');

    var CenterRipple = function (_Component) {
        _inherits(CenterRipple, _Component);

        function CenterRipple(props) {
            _classCallCheck(this, CenterRipple);

            var _this = _possibleConstructorReturn(this, _Component.call(this, props));

            _this.state = {
                now: 't' + 0
            };

            _this.willLeave = _this.willLeave.bind(_this);
            return _this;
        }

        CenterRipple.prototype.animate = function animate() {
            this.setState({
                now: 't' + Date.now()
            });
        };

        CenterRipple.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
            if (nextProps.flag === !this.props.flag) {
                this.animate();
            }
        };

        CenterRipple.prototype.shouldCompoenntUpdate = function shouldCompoenntUpdate(nextProps, nextState) {
            return this.props.opacity !== nextProps.opacity || this.props.scale !== nextProps.scale || this.props.flag !== nextProps.flag || this.state.now !== nextState.now;
        };

        CenterRipple.prototype.willLeave = function willLeave(key, valOfKey) {
            return _extends({}, valOfKey, {
                opacity: (0, _reactMotion.spring)(0, { stiffness: 60, damping: 15 }),
                scale: (0, _reactMotion.spring)(this.props.scale, { stiffness: 60, damping: 15 })
            });
        };

        CenterRipple.prototype.render = function render() {
            var _props = this.props,
                opacity = _props.opacity,
                children = _props.children;

            var now = this.state.now;

            var styles = [{
                key: now,
                style: {
                    opacity: (0, _reactMotion.spring)(opacity),
                    scale: (0, _reactMotion.spring)(0)
                }
            }];

            var className = cx(this.props).build();
            var circleClassName = cx().part('circle').build();

            return _react2.default.createElement(
                _reactMotion.TransitionMotion,
                {
                    willLeave: this.willLeave,
                    styles: styles },
                function (interpolatedStyles) {
                    return _react2.default.createElement(
                        'div',
                        { className: className },
                        interpolatedStyles.map(function (config) {
                            var _config$style = config.style,
                                opacity = _config$style.opacity,
                                scale = _config$style.scale;

                            return _react2.default.createElement(_RippleCircle2.default, {
                                key: config.key,
                                className: circleClassName,
                                opacity: opacity,
                                scale: scale });
                        }),
                        children
                    );
                }
            );
        };

        return CenterRipple;
    }(_react.Component);

    exports.default = CenterRipple;


    CenterRipple.defaultProps = {
        opacity: 0.5,
        scale: 2
    };

    CenterRipple.propTypes = {
        opacity: _propTypes2.default.number.isRequired,
        scale: _propTypes2.default.number.isRequired,
        flag: _propTypes2.default.bool
    };

    CenterRipple.displayName = 'CenterRipple';
});
//# sourceMappingURL=CenterRipple.js.map
