(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes);
        global.RippleCircle = mod.exports;
    }
})(this, function (exports, _react, _propTypes) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var RippleCircle = function (_Component) {
        _inherits(RippleCircle, _Component);

        function RippleCircle() {
            _classCallCheck(this, RippleCircle);

            return _possibleConstructorReturn(this, _Component.apply(this, arguments));
        }

        RippleCircle.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
            var _props = this.props,
                opacity = _props.opacity,
                scale = _props.scale;


            return opacity !== nextProps.opacity || scale !== nextProps.scale;
        };

        RippleCircle.prototype.render = function render() {
            var _props2 = this.props,
                style = _props2.style,
                opacity = _props2.opacity,
                scale = _props2.scale,
                other = _objectWithoutProperties(_props2, ['style', 'opacity', 'scale']);

            return _react2.default.createElement('div', _extends({}, other, {
                style: _extends({}, style, {
                    opacity: opacity,
                    WebkitTransform: 'scale(' + scale + ')',
                    MozTransform: 'scale(' + scale + ')',
                    msTransform: 'scale(' + scale + ')',
                    transform: 'scale(' + scale + ')'
                }) }));
        };

        return RippleCircle;
    }(_react.Component);

    exports.default = RippleCircle;


    RippleCircle.displayName = 'RippleCircle';

    RippleCircle.defaultProps = {
        opacity: 0.3,
        scale: 2
    };

    RippleCircle.propTypes = {
        opacity: _propTypes2.default.number.isRequired,
        scale: _propTypes2.default.number.isRequired
    };
});
//# sourceMappingURL=RippleCircle.js.map
