(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', './Option', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('./Option'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.Option, global.cxBuilder);
        global.OptionGroup = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _Option, _cxBuilder) {
    'use strict';

    exports.__esModule = true;
    exports.default = SelectOptionGroup;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Option2 = _interopRequireDefault(_Option);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    var cx = (0, _cxBuilder.create)('SelectOptionGroup');

    /**
     * OptionGroup
     *
     * @class
     * @param {*} props 属性
     */
    function SelectOptionGroup(props) {
        var value = props.value,
            children = props.children,
            disabled = props.disabled,
            label = props.label,
            onClick = props.onClick;


        return _react2.default.createElement(
            'div',
            { className: cx(props).build() },
            _react2.default.createElement(
                'h4',
                { className: cx().part('title').build() },
                label
            ),
            _react2.default.createElement(
                'div',
                { className: cx().part('list').build() },
                _react.Children.map(children, function (child, index) {

                    if (child.type !== 'option') {
                        return null;
                    }

                    return _react2.default.createElement(_Option2.default, _extends({}, child.props, {
                        key: child.props.value,
                        selected: child.props.value === value,
                        disabled: child.props.disabled || disabled,
                        onClick: onClick }));
                })
            )
        );
    }

    SelectOptionGroup.propTypes = {
        disabled: _propTypes2.default.bool,
        label: _propTypes2.default.string.isRequired
    };
});
//# sourceMappingURL=OptionGroup.js.map
