(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder', '../Tooltip'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'), require('../Tooltip'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder, global.Tooltip);
        global.Bar = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder, _Tooltip) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Tooltip2 = _interopRequireDefault(_Tooltip);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('SliderBar');

    var SliderBar = function (_Component) {
        _inherits(SliderBar, _Component);

        function SliderBar() {
            _classCallCheck(this, SliderBar);

            return _possibleConstructorReturn(this, _Component.apply(this, arguments));
        }

        SliderBar.prototype.render = function render() {
            var _props = this.props,
                height = _props.height,
                maximum = _props.maximum,
                minimum = _props.minimum,
                value = _props.value,
                disableFocusRipple = _props.disableFocusRipple,
                pointerSize = _props.pointerSize,
                active = _props.active,
                states = _props.states,
                variants = _props.variants,
                rest = _objectWithoutProperties(_props, ['height', 'maximum', 'minimum', 'value', 'disableFocusRipple', 'pointerSize', 'active', 'states', 'variants']);

            var percent = (value - minimum) / (maximum - minimum) * 100 + '%';

            var activeStyle = {
                width: percent
            };

            var pointerStyle = {};
            var outerPointerStyle = {};

            if (pointerSize) {
                pointerStyle.width = pointerStyle.height = pointerSize;

                if (typeof pointerSize === 'string') {
                    var unit = pointerSize.replace(/\d(\.)?\d*/, '');
                    var _value = parseFloat(pointerSize);
                    outerPointerStyle.width = outerPointerStyle.height = _value * 2 + unit;
                    outerPointerStyle.marginTop = -_value + unit;
                    pointerStyle.marginTop = -_value / 2 + unit;
                } else {
                    outerPointerStyle.width = outerPointerStyle.height = pointerSize * 2;
                    outerPointerStyle.marginTop = -pointerSize;
                    pointerStyle.marginTop = -pointerSize / 2;
                }
            }

            var className = cx().part('wrapper').addVariants(variants).addStates(_extends({}, states, { active: active })).build();

            return _react2.default.createElement(
                'div',
                _extends({}, rest, { className: className }),
                _react2.default.createElement(
                    'div',
                    { style: { height: height }, className: cx(this.props).build() },
                    _react2.default.createElement('div', { style: activeStyle, className: cx().part('active').build() }),
                    _react2.default.createElement(_Tooltip2.default, {
                        content: value,
                        style: _extends({ left: percent }, pointerStyle),
                        className: cx().part('pointer').build() }),
                    disableFocusRipple ? null : _react2.default.createElement('div', {
                        style: _extends({ left: percent }, outerPointerStyle),
                        className: cx().part('pointer-outer').build() })
                )
            );
        };

        return SliderBar;
    }(_react.Component);

    exports.default = SliderBar;


    SliderBar.displayName = 'SliderBar';

    SliderBar.propTypes = {
        width: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
        height: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
        maximum: _propTypes2.default.number,
        minimum: _propTypes2.default.number,
        disableFocusRipple: _propTypes2.default.bool
    };

    SliderBar.defaultProps = {
        height: 2,
        width: '100%',
        disableFocusRipple: false
    };
});
//# sourceMappingURL=Bar.js.map
