(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', '../Icon', './Column'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('../Icon'), require('./Column'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.Icon, global.Column);
        global.SelectorColumn = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _Icon, _Column) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Icon2 = _interopRequireDefault(_Icon);

    var _Column2 = _interopRequireDefault(_Column);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var TableSelectorColumn = function (_Component) {
        _inherits(TableSelectorColumn, _Component);

        function TableSelectorColumn() {
            _classCallCheck(this, TableSelectorColumn);

            return _possibleConstructorReturn(this, _Component.apply(this, arguments));
        }

        TableSelectorColumn.prototype.render = function render() {
            return null;
        };

        return TableSelectorColumn;
    }(_react.Component);

    exports.default = TableSelectorColumn;


    TableSelectorColumn.displayName = 'TableSelectorColumn';

    TableSelectorColumn.icons = {
        radio: {
            checked: 'radio-button-checked',
            unchecked: 'radio-button-unchecked'
        },
        checkbox: {
            checked: 'check-box',
            unchecked: 'check-box-outline-blank'
        }
    };

    TableSelectorColumn.getIcon = function (multiple, selected) {
        var icons = TableSelectorColumn.icons[multiple ? 'checkbox' : 'radio'];
        return icons[selected ? 'checked' : 'unchecked'];
    };

    TableSelectorColumn.cellRenderer = function (props) {
        var part = props.part,
            columnData = props.columnData,
            rowIndex = props.rowIndex;

        var multiple = columnData.multiple;

        if (!multiple && part !== 'body') {
            return null;
        }

        var isSelected = part === 'body' ? columnData.isSelected(rowIndex) : columnData.isAllSelected();

        return _react2.default.createElement(_Icon2.default, {
            onClick: TableSelectorColumn.onCellClick.bind(null, props),
            icon: TableSelectorColumn.getIcon(multiple, isSelected),
            states: { selected: isSelected },
            variants: ['table-selector'] });
    };

    TableSelectorColumn.onCellClick = function (props) {
        var part = props.part,
            rowIndex = props.rowIndex,
            columnData = props.columnData;

        var handler = columnData[part === 'body' ? 'onSelect' : 'onSelectAll'];

        if (typeof handler === 'function') {
            handler(rowIndex);
        }
    };

    TableSelectorColumn.propTypes = _extends({}, _Column2.default.propTypes, {

        isSelected: _propTypes2.default.func.isRequired,
        isAllSelected: _propTypes2.default.func.isRequired,
        onSelect: _propTypes2.default.func,
        onSelectAll: _propTypes2.default.func,
        name: _propTypes2.default.string

    });

    /**
     * 最关键的东西在这里
     */
    TableSelectorColumn.defaultProps = _extends({}, _Column2.default.defaultProps, {
        width: 66,
        grow: 0,
        shrink: 0,
        cellRenderer: TableSelectorColumn.cellRenderer,
        headerRenderer: TableSelectorColumn.headerRenderer,
        footerRenderer: TableSelectorColumn.footerRenderer,
        align: 'center',
        dataKey: '',
        multiple: false
    });

    TableSelectorColumn._TABLE_COMPONENT_ = 'COLUMN';
});
//# sourceMappingURL=SelectorColumn.js.map
