(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'prop-types', './Row'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('prop-types'), require('./Row'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.propTypes, global.Row);
        global.SelectorRow = mod.exports;
    }
})(this, function (exports, _propTypes, _Row2) {
    'use strict';

    exports.__esModule = true;

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Row3 = _interopRequireDefault(_Row2);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var SelectorRow = function (_Row) {
        _inherits(SelectorRow, _Row);

        function SelectorRow() {
            _classCallCheck(this, SelectorRow);

            return _possibleConstructorReturn(this, _Row.apply(this, arguments));
        }

        SelectorRow.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {

            if (nextProps.selected !== this.props.selected) {
                return true;
            }

            return _Row.prototype.shouldComponentUpdate.call(this, nextProps, nextState);
        };

        return SelectorRow;
    }(_Row3.default);

    exports.default = SelectorRow;


    SelectorRow.propTypes = _extends({}, _Row3.default.propTypes, {
        selected: _propTypes2.default.bool.isRequired
    });

    SelectorRow.defaultProps = _extends({}, _Row3.default.defaultProps, {
        selected: false
    });
});
//# sourceMappingURL=SelectorRow.js.map
