(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder', './Row', 'melon-core/util/shallowEqual'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'), require('./Row'), require('melon-core/util/shallowEqual'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder, global.Row, global.shallowEqual);
        global.TableBody = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder, _Row, _shallowEqual) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Row2 = _interopRequireDefault(_Row);

    var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('TableBody');

    var TableBody = function (_Component) {
        _inherits(TableBody, _Component);

        function TableBody() {
            _classCallCheck(this, TableBody);

            return _possibleConstructorReturn(this, _Component.apply(this, arguments));
        }

        TableBody.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
            var _props = this.props,
                columns = _props.columns,
                dataSource = _props.dataSource;


            return !(0, _shallowEqual2.default)(nextProps.columns, columns) || !(0, _shallowEqual2.default)(dataSource, nextProps.dataSource);
        };

        TableBody.prototype.render = function render() {
            var _props2 = this.props,
                dataSource = _props2.dataSource,
                columns = _props2.columns;


            return _react2.default.createElement(
                'div',
                { className: cx(this.props).build() },
                dataSource.map(function (rowData, index) {
                    return _react2.default.createElement(_Row2.default, {
                        columns: columns,
                        index: index,
                        rowData: rowData });
                })
            );
        };

        return TableBody;
    }(_react.Component);

    exports.default = TableBody;


    TableBody.propTypes = {
        columns: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,
        dataSource: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired
    };
});
//# sourceMappingURL=TableBody.js.map
