(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder);
        global.Panel = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder) {
    'use strict';

    exports.__esModule = true;
    exports.default = TabsPanel;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    var cx = (0, _cxBuilder.create)('TabsPanel');

    /**
     * melon/Tabs/TabPanel
     *
     * @class
     * @param {Object}  props        属性
     * @param {boolean} props.active 是否选中
     * @return {ReactElement}
     */
    function TabsPanel(props) {
        var active = props.active,
            others = _objectWithoutProperties(props, ['active']);

        return _react2.default.createElement('div', _extends({}, others, { className: cx(props).addStates({ active: active }).build() }));
    }

    TabsPanel.displayName = 'TabsPanel';

    TabsPanel.propTypes = {
        active: _propTypes2.default.bool
    };

    TabsPanel.defaultProps = {
        active: false
    };
});
//# sourceMappingURL=Panel.js.map
