(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder);
        global.Tab = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder) {
    'use strict';

    exports.__esModule = true;
    exports.default = Tab;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    var cx = (0, _cxBuilder.create)('TabsItem');

    /* eslint-disable fecs-prefer-class */

    /**
     * melon/Tabs/TabPanel
     *
     * @class
     * @param {Object}              props          属性
     * @param {number}              props.index    序号
     * @param {string|ReactElement} props.label    Tab上显示的内容
     * @param {boolean}             props.disabled 是否不可选
     * @param {boolean}             props.selected 是否选中
     * @return {ReactElement}
     */
    function Tab(props) {
        var selected = props.selected,
            disabled = props.disabled,
            label = props.label,
            index = props.index,
            _onClick = props.onClick,
            others = _objectWithoutProperties(props, ['selected', 'disabled', 'label', 'index', 'onClick']);

        var className = cx(props).addStates({ selected: selected, disabled: disabled }).build();

        return _react2.default.createElement(
            'li',
            _extends({}, others, {
                className: className,
                onClick: function onClick(e) {
                    return disabled || _onClick(index);
                } }),
            label
        );
    }

    Tab.propTypes = {
        label: _propTypes2.default.node,
        disabled: _propTypes2.default.bool
    };

    Tab.defaultProps = {
        disabled: false,
        selected: false
    };
});
//# sourceMappingURL=Tab.js.map
