(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-core/classname/cxBuilder'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-core/classname/cxBuilder'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.cxBuilder);
        global.Input = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _cxBuilder) {
    'use strict';

    exports.__esModule = true;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var cx = (0, _cxBuilder.create)('TextBoxInput');

    var TextBoxInput = function (_Component) {
        _inherits(TextBoxInput, _Component);

        function TextBoxInput() {
            _classCallCheck(this, TextBoxInput);

            return _possibleConstructorReturn(this, _Component.apply(this, arguments));
        }

        TextBoxInput.prototype.render = function render() {
            var _props = this.props,
                multiline = _props.multiline,
                rows = _props.rows,
                isFocus = _props.isFocus,
                value = _props.value,
                variants = _props.variants,
                states = _props.states,
                rest = _objectWithoutProperties(_props, ['multiline', 'rows', 'isFocus', 'value', 'variants', 'states']);

            var Text = multiline ? 'textarea' : 'input';
            var className = cx().addVariants(variants).addStates(_extends({}, states, {
                focus: isFocus
            })).build();

            var props = _extends({}, rest, {
                className: className,
                value: value,
                rows: multiline ? rows : null
            });

            return _react2.default.createElement(Text, props);
        };

        return TextBoxInput;
    }(_react.Component);

    exports.default = TextBoxInput;


    TextBoxInput.displayName = 'TextBoxInput';

    TextBoxInput.propTypes = {
        rows: _propTypes2.default.number
    };

    TextBoxInput.defaultProps = {
        rows: 2
    };
});
//# sourceMappingURL=Input.js.map
